#!/bin/bash
# This is a script in Bash.

# This script updates the file "raddim.h" according to resolution.  It
# takes two input arguments : the number of longitudes and the number
# of latitudes.

USAGE="usage: `basename $0` number_longitudes number_latitudes"

if (($# != 2))
    then
    echo "$USAGE"
    exit 1
fi

trap 'exit 1' ERR

set -x

# Traitement special pour le nouveau rayonnement de Laurent Li :
cd ../libf/phylmd
if [[ -f raddim.$1.$2.h ]]
    then
    ln -s raddim.$1.$2.h raddim.h
else
    # You can decrease the size of the executable file by creating the
    # file raddim.$1.$2.h
    ln -s raddim.defaut.h raddim.h
fi
