#!/bin/bash
# This is a script in Bash.

# This script collects input files necessary for the program
# "etat0_lim" and runs "etat0_lim".  The script takes one input
# argument : the number identifying the run.

# To stop if there are error anywhere in the following script

trap 'exit 1' ERR
set -x

# For LMDz not to stop in case of underflow.

export G95_FPU_UNDERFLOW=No

cd ../WORKDIR
rm -f *.nc *.def

# Link to "albedo", "amipbc_*", "ECPHY", "ECDYN", "landiceref",
# "Relief" and "Rugos":
ln -s $PWD/../INPUT/*.nc .

# Link to the NAMELIST

ln -s $PWD/../NAMELIST/*.def .

time ./etat0_lim > etat0_lim_out.txt 2>&1
echo -e '\a' # beep

mv start.nc ../START/restart1.nc
mv startphy.nc ../START/restartphy1.nc
mv limit.nc ../START
mv etat0_lim_out.txt ../OUTPUT
mv lmdz.out ../OUTPUT/etat0_lim.out
\rm *.nc *.def 
